#!/usr/bin/perl
# 
# $konsole = "/dev/ttyp1"; 
$konsole = "/dev/tty6"; 
$LOCKDATEI = "/home/solar/LCK.solar";
# $LOCKDATEI = "/home/www/SOLAR/LCK.solar";

# Korrektur eingespeiste Energie in kWh : 
# der Speicher im Wechselrichter scheint uebergelaufen zu sein.
# Diese Korrektur muss beim n-ten Ueberlauf ver-n-facht werden !
# Also wird zum WR-Wert "Gesamtertrag"addiert 
$korrektur=1*6553.6 ;        # das ist 64*1024/10

# Liest Datensaetze von /dev/ttyS1
# aus dem Solwex-Wechselrichter (bei uns Typ 5090)
# der Firma Karschny Electronik GmbH 24797 Breiholz
#
# Copyright 1998/1999 (c) Friege. Es gelten die Bedingungen
# der GNU-General-Public-License. Beachten Sie bitte auch die
# Bedingungen der verschiedenen Software-Pakete
#
# Grundlage dieser Entwicklung ist das freie Unix-System "Linux".
# Danke an alle seine Entwicklerinnen und Entwickler !
#
# Gisbert Friege Juni 1998 / Juni 1999
# mailto:gfriege@t-online.de

# =================================================================
#
# solar.pl [ -h | -o | -s {1..20 | 40..45 m1} | 
#	     -l {40..45} m1 m2 t | -a {40..45} t]
#
#	Das Programm holt Daten vom Solwex-Wechselrichter und gibt sie
#	auf die Konsole oder in eine HTML-Seite oder in eine Logger-Datei aus.
#
# 1. Parameter=Modus: -hilfe -online -single -logger -auto -h -o -s -l -a
# 2. Parameter=Befehlscode: 1..20 40..45 
# 3. Parameter=Multiplikator_1 (groesser, also aeltere Daten)
#              oder Anzahl der Tage zurueck : haenge d an die Anzahl 
#              oder Anzahl der Stunden zurueck : haenge h an die Anzahl 
# 4. Parameter=Multiplikator_2 (kleiner, also juengere Daten)
#              oder Anzahl der Tage zurueck : haenge d an die Anzahl 
#              oder Anzahl der Stunden zurueck : haenge h an die Anzahl 
#
# !!!!! notwendig :
# 3. oder 5. Parameter=Timeout fuer -a bzw. -l (in Minuten, bei -o und -s :=2)
# =================================================================
# Die fuer -online gewuenschten Befehle muessen hier in die 
#	Liste der Befehlscodes fuer die HTML-Ausgabe eingetragen werden.
#	Es duerfen keine Befehlscodes ausserhalb 01..20 angegeben werden !

@befliste = ('01','02','03','04','05','06','07');# ,'08','11','12','13','14','15');

# Die Befehle 1 bis 5 gehoeren wohl zum Standardumfang des Wechselrichters
# 	Anpassung an den Leistungsumfang des WR noetig !
# Insbesondere fuer Modultemperatur (10) und solare Einstrahlung (9)
# 	wird zusaetzliche Hardware benoetigt.
# Fuer diese beiden werden bei uns seltsamerweise (unsinnige) Werte ausgegeben.
# Die AC-Werte ( 11..14) liefern bei uns Fehlermeldungen des WR.
# Fuer Betriebstunden (15) und Wirkungsgrad (8) wird bei uns nichts ausgegeben.

# =================================================================
# im Folgenden muessen einige Pfade angepasst werden !
# =================================================================

# =================================================================
# Datenverkehr auf anderer Konsole beobachtbar
# $konsole = "/dev/ttyp1"; 
# $konsole = "/dev/tty6"; 

# =================================================================
# Pfad fuer die LOCK-Datei, deren Existenz einen zweiten 
# Programmaufruf verhindert. Sie dient gleichzeitig als
# Batch-Datei fuer den Timeout per at-job.
# $LOCKDATEI = "/home/solar/LCK.solar";

# =================================================================
# Der Pfad zu den LOGGER-Dateien, auf die dlog.exe zugreifen soll.
# dlog.exe sucht die Daten unterhalb seines Programmverzeichnisses
# Samba-Share -> S:\dlog\daten\dev00
# Bei Zeitangaben fuer den Logger-Zeitraum ( also nicht "auto" ) wird 
# als LOGpfad das aktuelle Verzeichnis benutzt.
$LOGpfad="/software/dlog/daten/dev00"; 

# =================================================================
# Alles was im folgenden Verzeichnis liegt wird nach dem taeglichen
# Loggerlauf ( solar.pl 40 -auto ) per ftp auf die Homepage geschickt. 
# siehe dazu das Script sol_auto.muster
$ZIPpfad="/home/solar/upload";

# =================================================================
# Pfad fuer die HTML-Datei 
$HTMLDATEI = "/home/solar/sol_onl.htm"; 

# =================================================================
# Ende des Pfadanpassungsteils
# =================================================================

die "solar.pl laeuft schon!" if -e $LOCKDATEI;

$mypid=$$; # process-ID
open(LCKDAT,"> $LOCKDATEI") || die "\nKann Lockdatei $LOCKDATEI nicht oeffnen\n";  
print LCKDAT "kill -KILL $mypid\nrm $LOCKDATEI\n" ;
close LCKDAT;
system("chmod 744 $LOCKDATEI");
 
open(CONS,">> $konsole") ;
# || die "\nKann $konsole nicht oeffnen\n";  


# =================================================================
use FileHandle;
use Time::Local;
# use POSIX "sys_wait_h";
use Process; # Modul von M.Schilli
$rettungsproc = Process-> new();

# =================================================================
# Modus
# =================================================================

$_ = @ARGV[0];
MODS: {
    /^-o/ && do { $modus = 1; last MODS; }; # -online
    /^-s/ && do { $modus = 2; last MODS; }; # -single
    /^-l/ && do { $modus = 3; last MODS; }; # -logger
    /^-a/ && do { $modus = 4; last MODS; }; # -auto
    lockweg();
    system ("less solar.txt"); # hier ggf. anderes Anzeigeprogramm eintragen !
    die "\n===Anzeige des Hilfetexts zum Programm solar.pl beendet.===\n";
        };

# =================================================================
# Parameterkontrolle
# =================================================================


if ($modus > 1)  # alle ausser -online brauchen den Befehlscode
{
    $befehl=@ARGV[1];
    ((($befehl > 0) && ($befehl < 21)) || (($befehl > 39) && ($befehl < 46))) || 
	do { lockweg(); 
	die "\n2. Argument: Befehlscodes: 1..20 , 40..45 \n";};
    $befehl = sprintf "%02d", $befehl; 
    @befliste = ($befehl); # ueberschreibt die Vorgabe fuer HTML-Ausgabe
}

if ($modus > 2 && $befehl < 40) 
{	lockweg(); 
	die "\n2. Argument: Befehlscodes fuer Logdateien: 40..45 \n";
};

if ($befehl > 39 && $modus < 4) # Modus 2 und 3 benoetigen Zeitangaben
{
    $tiefe1 = @ARGV[2];  
    ($tiefe1 ne '') || 
    do { lockweg() ;
    die "\n3. Argument: Zeitangabe fuer den Logger fehlt !\n";};
    if ($modus == 3)  {    
	$tiefe2 = @ARGV[3];
	($tiefe2 ne '') || 
	do { lockweg() ;
	die "\n4. Argument: 2.Zeitangabe fuer den Logger fehlt !\n";};
    }
}

# =================================================================
$startzeit = time;

# Logfiles anlegen/oeffnen fuer Modi 3 und 4
if ($modus>2) { 
    logdateien_verwalten(); 
};
# =================================================================

# =================================================================
# Bestimmung und Ueberpruefung der Logger-Multiplikatoren
# =================================================================

if ($befehl > 39)
{     
    $d_da = index $tiefe1,d;
    if ($d_da > 0 ) {$tiefe1=substr $tiefe1,0,$d_da;$tiefe1 = $tiefe1*144;}
    $h_da = index $tiefe1,h;
    if ($h_da > 0 ) {$tiefe1=substr $tiefe1,0,$h_da;$tiefe1=$tiefe1*6;}
    if ($modus > 2) 
    {        
	$d_da = index $tiefe2,d;
	if ($d_da > 0 ) {$tiefe2=substr $tiefe2,0,$d_da;$tiefe2=$tiefe2*144;}
	$h_da = index $tiefe2,h;
	if ($h_da > 0 ) {$tiefe2=substr $tiefe2,0,$h_da;$tiefe2=$tiefe2*6;}
	($tiefe1 >= $tiefe2) || 
	do { lockweg() ;
	die "\n1.Zeitangabe muss groesser oder gleich 2.Zeitangabe sein !\n";};
    } 
    else {$tiefe2=$tiefe1}; #fuer Modus 2
}
else {$tiefe1=1;$tiefe2=1}; # fuer Modus 1

# =================================================================
# Konstanten
# =================================================================

# Geraetenummer des Wechselrichters ( 01 Firmeneinstellung des WR )
$weri = '01';
# Geraetenummer des Computers ( FF deaktiviert Pruefcodeerkennung )
$compi = '03';

%bezeichnungen = (
		'01' => 'Solarleistung',  
		'02' => "Solarspannung",
		'03' => "Solarstrom",
		'04' => "Kuehlkoerpertemperatur",
		'05' => "DC Gesamtertrag",
		'06' => "Tagesspitzenleistung",
		'07' => "Netzfrequenz",
		'08' => "Wirkungsgrad",
		'09' => "Solare Einstrahlung",
		'10' => "Modultemperatur",
		'11' => "AC Spannung",
		'12' => "AC Strom",
		'13' => "AC Leistung",
		'14' => "AC Gesamtertrag",
		'15' => "Betriebsstunden",
		'16' => "Geraetestatus",
		'17' => "Geraetetyp",
		'18' => "Version WR-Software",
		'19' => "Softkey",
		'20' => "Netzimpedanz",
                '40' => "LOG Solarleistung",
                '41' => "LOG Solarspannung",
                '42' => "LOG Kuehlkoerpertemperatur",
                '43' => "LOG Einstrahlung",
                '44' => "LOG Modultemperatur",
                '45' => "LOG Fehlercode",
		 );

%einheiten = (		
		'01' => "W",  		
		'02' => "V",  
		'03' => "A",  		
		'04' => " C",  
		'05' => "kWh",  	
		'06' => "W",  
		'07' => "Hz",  		
		'08' => "%",  
		'09' => "W/m2",  
		'10' => " C",  
		'11' => "V",  
		'12' => "A",  
		'13' => "W",  
		'14' => "kWh",  
		'15' => "h",  
		'16' => "",  
		'17' => "",  
		'18' => "",  
		'19' => "",  
		'20' => "Ohm",  
                '40' => "W",
                '41' => "V",
                '42' => " C",
                '43' => "W/m2",
                '44' => " C",
                '45' => "",
		 );

# Werte werden zunaechst auf "keine gueltigen Daten gefunden" gesetzt
%werte = (
          '01' => -1,	'02' => -1,	'03' => -1,	'04' => -1,
	  '05' => -1,   '06' => -1,     '07' => -1,	'08' => -1,
	  '09' => -1,   '10' => -1,	'11' => -1,	'12' => -1,
          '13' => -1,   '14' => -1,	'15' => -1,     '16' => -1,
	  '17' => -1,	'18' => -1,     '19' => -1,	'20' => -1,
	  '40' => -1,   '41' => -1,	'42' => -1,
	  '43' => -1,   '44' => -1,	'45' => -1,
        );


# =================================================================

open(DEV, "+< /dev/ttyS1") || 
	do { lockweg() ;
	    die "Kann /dev/ttyS1 nicht oeffnen\n"; 
	};

# =================================================================
# Timeouts je nach Modus
$timeout = 2 ;
if ($modus == 3) { $timeout = @ARGV[4]; };
if ($modus == 4) { $timeout = @ARGV[2]; };
if ($timeout < 2) { $timeout=2; }; # sonst meckert at die Pluralform an
system("at now + $timeout minutes -f $LOCKDATEI &> myatjob");
# hole die at-job-Nummer aus der job-Zeile von myatjob
$atjobnr=`cat myatjob | grep Job | cut -d ' ' -f 2`;
#system("rm myatjob");

# =================================================================  
# Fuer Logger: einmal A1 senden: (auch bei "single")
# Vor einem Datenlogger-Lauf wird einmal der 
# Befehlscode "A1" ("freeze") gesendet. Dadurch wird der
# Auslesezeiger, relativ zu dem die Daten abgerufen weden,
# auf den aktuellen Datensatz des Ringspeichers gesetzt.
# Multi = 1 ist der letzte (aktuelle Wert) zum Aufrufzeitpunkt
# =================================================================

DEV->autoflush(1);

$lauf=0;
 if ($befehl > 39){
	    $anfbef = 'A1' ;	
	    $sendedaten = sprintf "%08d", 0;
	    $sendetele = "$weri;$compi;$anfbef;$sendedaten*";
	    $sendeprcode = xorsumme($sendetele);
	    $sende = "\$$sendetele$sendeprcode\r\n";
    	    print DEV $sende;
	    print CONS "\nPC-->WR $sende";
	    chomp($zeile=<DEV>); $lauf=1 ;
	    print CONS "     WR-->PC $zeile\r\n";
 }

# =================================================================

foreach $anfbef (@befliste) 
{
    for ($multi = $tiefe1; $multi > $tiefe2-1 ; $multi--)
    {
        do 
	{ 
	    # ====================================
	    # Anforderungszeile zusammenbauen und senden
	    $sendedaten = sprintf "%08d", $multi;
	    $sendetele = "$weri;$compi;$anfbef;$sendedaten*";
	    $sendeprcode = xorsumme($sendetele);
	    $sende = "\$$sendetele$sendeprcode\r\n";
	    # zur Programmkontrolle Ausgabe der Zeile auf 2.Konsole    
	    print CONS "\n $lauf :PC-->WR $sende";
	
	    print DEV $sende;
	    $rettungsproc->start(\&wecksender)|| die "Wecker-Fehler!\n";
            # meistens erstmal eine leere Zeile einlesen: warum bloss ?
            # aber nicht bei der ersten Anforderung
                if ($lauf > 0) {
                chomp($zeile=<DEV>);};
                $lauf++;
  	    chomp($zeile=<DEV>);
	    # wenn wir hier sind war das Einlesen erfolgreich, also 
	    $rettungsproc->kill();

	    # zur Programmkontrolle Ausgabe der Zeile auf 2.Konsole    
	    print CONS "     WR-->PC $zeile\r\n";
	
	    # Daten extrahieren 
	    $daten = pruefzeile($zeile);
	
	} until (substr($daten,0,1) ne "_"); # Fehlerstrings beginnen mit _
    
	# Daten in das Wertefeld eintragen
	$werte{$bef}=$daten;
    
	# ==================================
	# Aufbereitung der Daten:
	# fuehrende Nullen werden weggeworfen
	$werte{$bef}=~ s/^0*/ /;

	# DCgesamt und ACgesamt und Netzimpedanz werden durch 10 geteilt:
	if ($bef =='05') {$werte{$bef}=$werte{$bef}/10 };
	if ($bef =='14') {$werte{$bef}=$werte{$bef}/10 };
	if ($bef =='20') {$werte{$bef}=$werte{$bef}/10 };
	# Korrektur DCgesamt und ACgesamt (siehe Programmanfang)
	if ($bef =='05') {$werte{$bef}=$werte{$bef}+$korrektur };
	if ($bef =='14') {$werte{$bef}=$werte{$bef}+$korrektur };
        # Stromstaerken und Netzfrequenz durch 100:
	if ($bef =='03') {$werte{$bef}=$werte{$bef}/100};
	if ($bef =='07') {$werte{$bef}=$werte{$bef}/100};
	if ($bef =='12') {$werte{$bef}=$werte{$bef}/100};

	# ==================================
        $logzeit = $startzeit - ( $multi - 1 ) * 600; # jetzt: $multi=1
        $logzeitstr = zeit2str($zeit);

	# ==================================
        # Ausgabe der Daten auf die 1.Konsole
        if ($modus == 2){
    	    print "$logzeitstr $bezeichnungen{$bef} $werte{$bef} $einheiten{$bef}\n\n" ;
	}
	# ==================================
	# Ausgabe in die Logger-Dateien 
	if ($modus > 2){
	    if ($modus == 4 && zeit2mon($logzeit)>$lastmon) {  # Dateiwechsel !
		$lastmon++;
		close LOGA;close LOGB; # das waren VLOGs
		system "zip $VLOG_ZIP $VLOG_A $VLOG_B > /dev/null";
		open(LOGA, ">> $LOG_A") || 
    		do { atlockweg() ; die "Kann $LOG_A nicht oeffnen\n" };
		open(LOGB, ">> $LOG_B") || 
    		do { atlockweg() ; die "Kann $LOG_B nicht oeffnen\n" };
	    }
	    # Datum im Binaerformat fuer das dlog.exe-Programm
	    $binzeit=zeit2bin($logzeit);
	    $logwert = sprintf "%08d",($werte{$bef}) ;
	    print LOGA "$logzeitstr $logwert\n" ; # ASCII-Format wie bei D-LOG SX
	    print LOGB "$binzeit$logwert" ; # BINAER-Format wie bei D-LOG SX

        }
	# ==================================
    }	
} 

close(CONS);
close(DEV);

if ($modus > 2){
    close(LOGA);close(LOGB);
}
if ($modus == 4){
    system "zip $LOG_ZIP $LOG_A $LOG_B > /dev/null";
}

($modus == 1 ) || 
	do { atlockweg() ;
    	    exit;
	};

# =======================================================
# Ausgabe der Daten in eine neue HTML-Seite

system "rm -f sol_onl.htm";
open (HTM,">> sol_onl.htm") || 
    do { atlockweg() ;
        die "Fehler beim Oeffnen von sol_onl.htm";
    };
print HTM "<HTML>\n";

print HTM "<HEAD>\n";
print HTM "<meta http-equiv=\"expires\" content=\"0\">\n";
print HTM "<meta name=\"description\" content=\"Die aktuellen Betriebsdaten der
Photovoltaikanlage der Erich-Fried-Gesamtschule Wuppertal-Ronsdorf
im 15-Minuten-Takt\">\n";
print HTM "<meta name=\"author\" content=\"G.Friege\">\n";
print HTM "<meta name=\"keywords\" content=\"Solar, Photovoltaik, Solwex\">\n";
print HTM "</HEAD>\n";

print HTM "<TITLE>Solaranlage: Online</TITLE>\n";
print HTM "<BODY>\n";

print HTM "<CENTER>\n";
print HTM "<H1>Die aktuellen Daten der Solaranlage<P>\n";
print HTM "der Erich-Fried-Gesamtschule Ronsdorf</H1>\n";
print HTM "<P><HR>\n";
print HTM "<H3>Zeit: $logzeit</H3>\n";

print HTM "<P><TABLE BORDER>\n";
foreach $bef (@befliste) 
{
    print HTM "<TR>";
    print HTM "<TD><H2 ALIGN=CENTER>";
	print HTM "$bezeichnungen{$bef}\n";
    print HTM "</H2></TD>";
    print HTM "<TD><H2 ALIGN=CENTER>";
	print HTM "$werte{$bef}	$einheiten{$bef}\n";
    print HTM "</H2></TD>";
    print HTM "</TR>";
}
print HTM "</CENTER>\n";
print HTM "</TABLE>\n";
print HTM "<P><HR>\n";
print HTM "Diese Seite wird hoffentlich alle 15 Minuten aktualisiert.<P>\n";
print HTM "Bitte rufen Sie die Seite mit dem \"Neu laden\" - Befehl 
erneut auf.<P>\n";
print HTM "Bei einer Solarspannung unter 55 V DC (Stand-by-Betrieb des 
Wechselrichters) werden die Daten nicht erneuert.<P>\n 
Bei fehlerhaften Daten wird -1 angezeigt.<P>\n";
print HTM "<P><HR>\n";
print HTM "<TABLE><TR>\n";
print HTM "<TD>\n";
print HTM "<A HREF=\"mailto:gfriege\@t-online.de\"> eMail an G.Friege <\/A>\n";
print HTM "</TD>\n";
print HTM "<TD>\n";
print HTM "<A HREF=\"sol_how.htm\"> &Uuml;ber diese Seite <\/A>\n";
print HTM "</TD>\n";
print HTM "<TD>\n";
print HTM "<A HREF=\"sonnig.html\"> zur&uuml;ck zu sonnig <\/A>\n";
print HTM "</TD>\n";
print HTM "</TR></TABLE>\n";
print HTM "</BODY>\n</HTML>\n";

close(HTM);
atlockweg();
exit;

# =================================================================
# Subroutinen
# =================================================================

sub bin2zeit {
my $utage,$tage,$rzeit;
    $tage=unpack ("d1",$_[0]);
    $utage=$tage-25569;# print "$tage VB-Tage (seit 30.12.1889)\n";
    $rzeit=$utage*86400-7200;   # print "$utage Unix-Tage (seit 1.1.1970)\n";
    return $rzeit;
};

sub zeit2bin {
my $utage,$tage,$binz;
    $utage=($_[0]+7200)/86400;   # print "$utage Unix-Tage (seit 1.1.1970)\n";
    $tage=$utage+25569;# print "$tage VB-Tage (seit 30.12.1889)\n";
    $binz=pack ("d1",$tage);
    return $binz;
};

sub zeit2str {		# fuer ASCII-Ausgabe der Loggzeiten
my $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,$zeitstr;
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =localtime($_[0]);
    $zeitstr = sprintf "%02d.%02d.%4d %02d:%02d",$mday,$mon+1,$year+1900,$hour,$min;
    return $zeitstr;
};

sub zeit2mon {
my $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,$monum;
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =localtime($_[0]);
    $monum = $mon+1; 
    return $monum; # korrigierte Monatsnummer (1=Januar)
};
sub zeit2ja {
my $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,$ja;
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =localtime($_[0]);
    $ja = $year+1900; 
    return $ja; # korrigierte Jahreszahl (4stellig, y2k-faehig)
};
sub str2zeit {
my $da,$ti,$sec,$min,$hour,$mday,$mon,$year,$zeit;
    # Zeit-String zerlegen: tt.mm.yyyy hh:mm
    ($da,$ti)=split (/ /,$_[0]);
    ($mday,$mon,$year)=split (/\./,$da);
    ($hour,$min)=split (/:/,$ti);
    $zeit=timelocal($sec,$min,$hour,$mday,$mon,$year);
    return $zeit;
};
# =================================================================
sub lockweg 
{    system ("rm -f $LOCKDATEI") };
# =================================================================
sub atlockweg 
# raeumt auch den at-job weg,
# damit der naechste Lauf nicht vom jetzigen Timeout 
# erschlagen wird 
{ system ("atrm $atjobnr"); 
  system ("rm -f $LOCKDATEI") };
# =================================================================
sub xorsumme 		# ein Argument : zu pruefendes Telegramm
{
my $i,$xor,$dazu,$code;
	    $xor=0;
            for ($i = 0; $i < 17 ; $i++) 
	    {
		$dazu = ord ( substr ( $_[0], $i , 1 ));
    		$xor = $xor ^ $dazu;
	    }
	    $code = uc ( unpack ("H2",pack ("I", $xor))) ;
	    return $code;
};	    

sub pruefzeile # ein Argument: empfangene Zeile, die geprueft werden soll
		# gibt den Datensatz zurueck, falls kein Fehler,
		# gibt _xxxerr zurueck, falls Fehler aufgetreten
{
my $syn,$start,$tele,$dev1,$dev2,$bef,$tmp,$daten,$pruef,$prcode;
    $syn = join('',substr($_[0],3,1),substr($_[0],6,1),
		substr($_[0],9,1),substr($_[0],18,1)); # Syntax ;;;*
    $start = substr($_[0],0,1); # Startzeichen
    $tele=substr($_[0],1,20);   # Telegramm (ohne Startzeichen)
    ($dev1, $dev2, $bef, $tmp) = split (';',$tele); # Geraet1, Geraet2, Befehl
    ($daten, $pruef) = split ('\*',$tmp); # Datenblock, Pruefsumme

    if ( $syn ne ";;;*" ) {return "_synerr"} 
    else 
    {
        if ($start ne '&') {return "_starterr"}
        else 
        {
	    if (($dev1 ne $compi) or ($dev2 ne $weri)) {return "_deverr"}
	    else
	    {
	        if ($bef ne $anfbef) {return "_beferr"}
	        else 
		{
	    	    $prcode = xorsumme ($tele);
	    	    if ($prcode ne $pruef) {return "_prueferr"} 
	    	    else 
	    	    {
			return $daten;
	    	    }
		}    
	    }
	}
    }
};
# =================================================================
sub logdateien_verwalten 
{
    my $ext0,$ext,$sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,$dateidatum;
    $ext0=$befehl-40; $ext=sprintf "%03d", $ext0;
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =localtime($startzeit);

    if ($modus<4) { # fuer LOGGER mit "echter" Zeitangabe 
    	$dateidatum = sprintf "%02d.%02d.%02d.%02d",$mon+1,$mday,$hour,$min;
    	$LOG_A = "LGA_$ext.$dateidatum";
    	$LOG_B = "LGB_$ext.$dateidatum";
    	system "rm -f $LOG_A";
    	system "rm -f $LOG_B";
	open(LOGA, ">> $LOG_A") || 
        do { lockweg() ; die "Kann $LOG_A nicht oeffnen\n" };
	open(LOGB, ">> $LOG_B") || 
        do { lockweg() ; die "Kann $LOG_B nicht oeffnen\n" };

    } else { # fuer LOGGER mit "-auto":
	$aktmon=sprintf "%02d", zeit2mon($startzeit);
	$aktja=zeit2ja($startzeit);
	$aktja2=substr($aktja,-2,2);
	$monatjahr =  join('',$aktmon,$aktja2);
	if ( $aktmon == 1 ) { # fuer Januar
	    $vormon = "12" ; 
	    $vorjahr = $aktja - 1 ; $vorjahr=substr($vorjahr,-2,2) 
	} else { 
	    $vormon = $aktmon-1; $vormon=sprintf "%02d",$vormon;
	    $vorjahr=substr($aktja,-2,2); 
	};
	$vormonatjahr =  join ('',$vormon,$vorjahr);

	$LOG_A = "$LOGpfad/$ext\_$monatjahr.txt"; 
	$LOG_B = "$LOGpfad/log_$monatjahr.$ext";  
	$LOG_ZIP = "$ZIPpfad/$ext\_$monatjahr.zip"; 
	$VLOG_A = "$LOGpfad/$ext\_$vormonatjahr.txt"; 
	$VLOG_B = "$LOGpfad/log_$vormonatjahr.$ext";  
	$VLOG_ZIP = "$ZIPpfad/$ext\_$vormonatjahr.zip"; 

	if (-e $LOG_B){	    # Datei fuer aktuellen Monat ist schon angefangen
			    # und wird weitergeschrieben
	    open(INDAT, "< $LOG_B") || 
	    do { lockweg() ; 
		die "Kann $LOG_B nicht oeffnen\n" ;
	    };
	    seek INDAT,-16,2;           # 16 Byte vor Ende
	    read INDAT,$lastbinzeit,16; # ergibt letzte Zeitangabe im Logfile
	    close INDAT;
	    open(LOGA, ">> $LOG_A") || 
    	    do { lockweg() ; 
		die "Kann $LOG_A nicht oeffnen\n" ;
	    };
	    open(LOGB, ">> $LOG_B") || 
    	    do { lockweg() ; 
	    die "Kann $LOG_B nicht oeffnen\n" ;
	    };
	} else { 	# Datei fuer aktuellen Monat exist. noch nicht:
		        # versuche, Vormonatsdatei zu verwenden
	    if (-e $VLOG_B){     # weiterschreiben falls vorhanden
		open(INDAT, "< $VLOG_B") || die "Kann $VLOG_B nicht oeffnen\n"; 
		seek INDAT,-16,2;           # 16 Byte vor Ende
		read INDAT,$lastbinzeit,16; # ergibt letzte Zeitangabe im Logfile
		close INDAT;
		open(LOGA, ">> $VLOG_A") || 
        	do { lockweg() ; 
		    die "Kann $VLOG_A nicht oeffnen\n" ;
		};
		open(LOGB, ">> $VLOG_B") || 
        	do { lockweg() ; 
		    die "Kann $VLOG_B nicht oeffnen\n" ;
		};
	    }
	}
	$lastzeit=bin2zeit($lastbinzeit);
	$zeitdiff=$startzeit-$lastzeit; # das sind Sekunden
	$tiefe1=int( ($zeitdiff-1)/600 ); # 10-Minuten-Einheiten, 
			    # aber nicht auf die gleiche Minute beginnen
	$tiefe2=1;
	# oder: zum Testen von -a : z.B. nur 200 Saetze holen:
	# $tiefe2=$tiefe1 - 199;
 	$lastmon=zeit2mon($lastzeit); # fuer Dateiwechselkriterium
	$lastja=zeit2ja($lastzeit);
    } # Ende if (modus<4)
}; # Ende sub

sub wecksender { 
    my $wnr,$wt;
    for ($wnr=1;$wnr<=20;$wnr++){
	for ($wt=1;$wt<=100000;$wt++){ };
	print DEV $sende ; 
    }
exit 0;
};
